module Tokens where

data Token a = 
   LBrace a
 | RBrace a
 | LBrack a
 | RBrack a
 | LPar a
 | RPar a
 | Ass a
 | Ife a
 | Colon a
 | Plus a
 | Minus a
 | Times a
 | Div a
 | Def a
 | Lt a
 | Le a
 | Gt a
 | Ge a
 | Eq a
 | Ne a
 | Amp a
 | And a
 | Or a
 | Jump a
 | CJump a
 | Mem a
 | Seq a
 | Exp a
 | Call a
 | Fct a
 | Reg a
 | Loc a
 | Adr a
 | Comma a
 | Semicol a
 | Const Integer a
 | Label String a
 | Register String a
 | Id String a
 deriving (Eq,Read,Show)

filterPn :: String -> String
filterPn [] = []
filterPn (' ':'(':'P':'n': s) = filterPn (tail $ dropWhile (/= ')') s)
filterPn (c:cs) = c:filterPn cs

token_pos (Fct p) = p
token_pos (Reg p) = p
token_pos (Loc p) = p
token_pos (Adr p) = p
token_pos (Def p) = p
token_pos (Amp p) = p
token_pos (Exp p) = p
token_pos (Call p) = p
token_pos (LBrace p) = p
token_pos (RBrace p) = p
token_pos (LBrack p) = p
token_pos (RBrack p) = p
token_pos (LPar p) = p
token_pos (RPar p) = p
token_pos (Ass p) = p
token_pos (Ife p) = p
token_pos (Colon p) = p
token_pos (Plus p) = p
token_pos (Minus p) = p
token_pos (Times p) = p
token_pos (Div p) = p
token_pos (Lt p) = p
token_pos (Le p) = p
token_pos (Gt p) = p
token_pos (Ge p) = p
token_pos (Eq p) = p
token_pos (Ne p) = p
token_pos (And p) = p
token_pos (Or p) = p
token_pos (Jump p) = p
token_pos (CJump p) = p
token_pos (Mem p) = p
token_pos (Seq p) = p
token_pos (Comma p) = p
token_pos (Semicol p) = p
token_pos (Const _ p) = p
token_pos (Label _ p) = p
token_pos (Register _ p) = p
--token_pos (Loc _ p) = p
--token_pos (Reg _ p) = p
token_pos (Id _ p) = p
